码迷,mamicode.com
首页 > 其他好文 > 详细

1. (LeetCode) 两数之和

时间:2019-06-01 16:30:29      阅读:97      评论:0      收藏:0      [点我收藏+]

标签:integer   get   hash   exception   solution   for循环   没有   continue   contain   

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1]

我的解法

public int[] twoSum(int[] nums, int target) {
        int i = 0;
        int j = 0;
        for(i = 0; i < nums.length; i++) {
            for (j = i + 1; j < nums.length; j++) {
                if ((nums[i] + nums[j]) == target) {
                    int[] result = new int[]{i, j};
                    return result;
                } else {
                    continue;
                }
            }
        }
        return new int[0];
    }

很明显,两次for循环,最笨的方法,一点技巧都没有。

时间复杂度O(n2) 空间复杂度O(1)

解法1

优先降低时间复杂度 O(n2) 能不能降为O(n)呢

这里需要引入额外的存储结构来实现这个需求

思路:

  1. 先把nums怼进map中,key 为nums[x] value为下标x
  2. 再循环nums,巧用 target - nums[x] 的差值 反向查找对应的j值,这要就能取到x,j的值返回

(这里是说每种输入只有一种答案)

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        map.put(nums[i], i);
    }
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement) && map.get(complement) != i) {
            return new int[] { i, map.get(complement) };
        }
    }
    throw new IllegalArgumentException("No two sum solution");
}

时间复杂度O(n) 空间复杂度O(n)

解法2

上面解法中两个for循环看起来也不爽,能不能降低为一个for循环呢

思路

  1. 先在map中找有没有存在的值,再put进map
public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement)) {
            return new int[] { map.get(complement), i };
        }
        map.put(nums[i], i);
    }
    throw new IllegalArgumentException("No two sum solution");
}

1. (LeetCode) 两数之和

标签:integer   get   hash   exception   solution   for循环   没有   continue   contain   

原文地址:https://www.cnblogs.com/adroit/p/10959942.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!